/* engine.h
 *
 * ZEthereal -- Ethereal for the Sharp Zaurus
 * Copyright (C) 2003  Philippe Biondi <biondi@cartel-securite.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#ifndef ENGINE_H
#define ENGINE_H

extern "C" {
#include "../config.h"
#include <glib.h>
#include "../file.h"
extern capture_file cfile;
}

class Engine 
{ 

public:
	Engine(void);
	~Engine(void);


// Get
	GList *get_interfaces(void);
	void free_interfaces(GList *l);
	int is_main_instance(void);

// Set
	void set_count(int c);
	void set_filter(const char *f);
	void set_rfilter(const char *rf);
	void set_interface(const char *i);
	void set_filename(const char *f);
	void set_promisc(int p);
	void set_resolv_flags(int dns, int mac, int port);

// Actions
	void do_capture();
	void do_stop_capture();
	void do_read_file();
	       
// Debug
	void dump_state(char *title = "");


protected:
	void kill_child();

	int childpid;
	int forked;

	int promisc;
	int count;
	int resolv_flags;
	char *filter;
	char *rfilter;
	char *interface;
	char *filename;
};

#endif
